from DisplayNode import *

class GameCharacter(DisplayNode):
    def __init__(self):
        DisplayNode.__init__(self)
        self.health = 100
        self.maxHealth = 100
        self.maxAttack = 200
        self.base_attack = 10 #items and lvl give you more base dmg
        self.base_defence = 0.01 #items and lvl give base def
        self.bonus_attack = 0; #attack bonus lvl and patterns etc.
        self.width = 200
        self.height = 300
        self.level = 1
        self.drawBoundingBox = True

        self.attack_lable = pyglet.text.Label("Atk: ", font_name='Times New Roman',\
        font_size=20, x=20, y=10, anchor_x ='center', anchor_y = 'center')
        
        self.health_lable = pyglet.text.Label("Hp: ", font_name='Times New Roman',\
        font_size=20, x=20, y=40, anchor_x ='center', anchor_y = 'center')

        self.addChild(self.attack_lable)
        self.addChild(self.health_lable)

        self.health_bar = DisplayNode()
        self.attack_bar = DisplayNode()
        
        self.health_bar.pos = (40, 40)
        self.health_bar.anchor = (0, 0.5)
        self.health_bar.width = self.width * 0.7
        self.health_bar.height = 20 
        self.health_bar.boxColor = (0, 255, 0)
        self.health_bar.drawBoundingBox = True

        self.attack_bar.pos = (40, 10)
        self.attack_bar.anchor = (0, 0.5)
        self.attack_bar.width = self.base_attack * 1.0/self.maxAttack  * self.width * 0.7
        self.attack_bar.height = 20 
        self.attack_bar.boxColor = (255, 0, 0)
        self.attack_bar.drawBoundingBox = True

        self.addChild(self.attack_bar)
        self.addChild(self.health_bar)

    def setBaseAttack(self, dmg):
        self.base_attack = dmg
        self.attack_bar.width = self.base_attack * 1.0/self.maxAttack  * self.width * 0.7

    #bonus attack is attack % on base attack.
    def getAttack(self):
        return self.base_attack + self.base_attack * self.bonus_attack; 

    #armor takes some percentage of of the dmg
    def attackWith(self, dmg):
        self.health -= (dmg - self.base_defence*dmg)
        self.health_bar.width = (self.health*1.0/self.maxHealth) * self.width * 0.7 

class PlayerCharacter(GameCharacter):
    def __init__(self):
        GameCharacter.__init__(self)
        self.boxColor = (128, 128, 128)
        self.setBaseAttack(50)

    def setBonusDamage(self, dmg):
        self.bonus_attack = dmg 

class EnemyCharacter(GameCharacter):
    def __init__(self):
        GameCharacter.__init__(self)

    def update(self, dt):
        pass


